%     VIRTUAL HC - программа для получения эффективных свойств сотовых заполнителей
%     Copyright (C) 2018-2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [RVE_Frame_Points, RVE_Frame_Size] = Construct_RVE_Shell(RVE_Type, RVE_Geom_Model, ...
                                Model_EDGE_a, ...
                                Model_WRENCH_h, ...
                                Model_EDGES_ANGLE_a, Model_EDGES_ANGLE_b, Model_EDGES_ANGLE_alpha, ...
                                Model_RVE_SIZE_L, Model_RVE_SIZE_W, ...
                                Model_RVE_SIZE_EDGE_L, Model_RVE_SIZE_EDGE_W, Model_RVE_SIZE_EDGE_a)

global ErrCode;

fprintf (1, 'Создание базовых точек для оболочечной ячейки...        ');

RVE_Frame_Points = zeros(12,2);
RVE_Frame_Size = zeros(1,2);

switch RVE_Geom_Model
    
    case 'EDGE'
        
        switch RVE_Type
            
            case 'TYPE_A'
                
                RVE_Frame_Points(1,:) = [-Model_EDGE_a * 3/2, -Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(2,:) = [-Model_EDGE_a/2, -Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(3,:) = [Model_EDGE_a/2, -Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(4,:) = [Model_EDGE_a * 3/2, -Model_EDGE_a * sqrt(3)/2];
                
                RVE_Frame_Points(5,:) = [-Model_EDGE_a * 3/2, 0];
                RVE_Frame_Points(6,:) = [-Model_EDGE_a, 0];
                RVE_Frame_Points(7,:) = [Model_EDGE_a, 0];
                RVE_Frame_Points(8,:) = [Model_EDGE_a * 3/2, 0];
                
                RVE_Frame_Points(9,:) = [-Model_EDGE_a * 3/2, Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(10,:) = [-Model_EDGE_a/2, Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(11,:) = [Model_EDGE_a/2, Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(12,:) = [Model_EDGE_a * 3/2, Model_EDGE_a * sqrt(3)/2];
                
                RVE_Frame_Size = RVE_Frame_Points(12,:) - RVE_Frame_Points(1,:);
                
            case 'TYPE_B'
                
                RVE_Frame_Points(1,:) = [-Model_EDGE_a * 3/2, 0];
                RVE_Frame_Points(2,:) = [-Model_EDGE_a/2, 0];
                RVE_Frame_Points(3,:) = [Model_EDGE_a/2, 0];
                RVE_Frame_Points(4,:) = [Model_EDGE_a * 3/2, 0];
                
                RVE_Frame_Points(5,:) = [-Model_EDGE_a * 3/2, Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(6,:) = [-Model_EDGE_a, Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(7,:) = [Model_EDGE_a, Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(8,:) = [Model_EDGE_a * 3/2, Model_EDGE_a * sqrt(3)/2];
                
                RVE_Frame_Points(9,:) = [-Model_EDGE_a * 3/2, -Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(10,:) = [-Model_EDGE_a, -Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(11,:) = [Model_EDGE_a, -Model_EDGE_a * sqrt(3)/2];
                RVE_Frame_Points(12,:) = [Model_EDGE_a * 3/2, -Model_EDGE_a * sqrt(3)/2];
                
                RVE_Frame_Size = RVE_Frame_Points(8,:) - RVE_Frame_Points(9,:);
                
            otherwise
                
                fprintf (1, '\nОшибка функции Construct_RVE_Shell: недопустимое значение параметра RVE_Type !\n');
                ErrCode = -1;
                return;
            
        end
        
    case 'WRENCH'
        
        switch RVE_Type
            
            case 'TYPE_A'
                
                RVE_Frame_Points(1,:) = [-3*Model_WRENCH_h/2/sqrt(3), -Model_WRENCH_h/2];
                RVE_Frame_Points(2,:) = [-Model_WRENCH_h/2/sqrt(3), -Model_WRENCH_h/2];
                RVE_Frame_Points(3,:) = [Model_WRENCH_h/2/sqrt(3), -Model_WRENCH_h/2];
                RVE_Frame_Points(4,:) = [3*Model_WRENCH_h/2/sqrt(3), -Model_WRENCH_h/2];
                
                RVE_Frame_Points(5,:) = [-3*Model_WRENCH_h/2/sqrt(3), 0];
                RVE_Frame_Points(6,:) = [-Model_WRENCH_h/sqrt(3), 0];
                RVE_Frame_Points(7,:) = [Model_WRENCH_h/sqrt(3), 0];
                RVE_Frame_Points(8,:) = [3*Model_WRENCH_h/2/sqrt(3), 0];
                
                RVE_Frame_Points(9,:) = [-3*Model_WRENCH_h/2/sqrt(3), Model_WRENCH_h/2];
                RVE_Frame_Points(10,:) = [-Model_WRENCH_h/2/sqrt(3), Model_WRENCH_h/2];
                RVE_Frame_Points(11,:) = [Model_WRENCH_h/2/sqrt(3), Model_WRENCH_h/2];
                RVE_Frame_Points(12,:) = [3*Model_WRENCH_h/2/sqrt(3), Model_WRENCH_h/2];
                
                RVE_Frame_Size = RVE_Frame_Points(12,:) - RVE_Frame_Points(1,:);
                
            case 'TYPE_B'
                
                RVE_Frame_Points(1,:) = [-3*Model_WRENCH_h/2/sqrt(3), 0];
                RVE_Frame_Points(2,:) = [-Model_WRENCH_h/2/sqrt(3), 0];
                RVE_Frame_Points(3,:) = [Model_WRENCH_h/2/sqrt(3), 0];
                RVE_Frame_Points(4,:) = [3*Model_WRENCH_h/2/sqrt(3), 0];
                
                RVE_Frame_Points(5,:) = [-3*Model_WRENCH_h/2/sqrt(3), Model_WRENCH_h/2];
                RVE_Frame_Points(6,:) = [-Model_WRENCH_h/sqrt(3), Model_WRENCH_h/2];
                RVE_Frame_Points(7,:) = [Model_WRENCH_h/sqrt(3), Model_WRENCH_h/2];
                RVE_Frame_Points(8,:) = [3*Model_WRENCH_h/2/sqrt(3), Model_WRENCH_h/2];
                
                RVE_Frame_Points(9,:) = [-3*Model_WRENCH_h/2/sqrt(3), -Model_WRENCH_h/2];
                RVE_Frame_Points(10,:) = [-Model_WRENCH_h/sqrt(3), -Model_WRENCH_h/2];
                RVE_Frame_Points(11,:) = [Model_WRENCH_h/sqrt(3), -Model_WRENCH_h/2];
                RVE_Frame_Points(12,:) = [3*Model_WRENCH_h/2/sqrt(3), -Model_WRENCH_h/2];
                
                RVE_Frame_Size = RVE_Frame_Points(8,:) - RVE_Frame_Points(9,:);
                
            otherwise
                
                fprintf (1, '\nОшибка функции Construct_RVE_Shell: недопустимое значение параметра RVE_Type !\n');
                ErrCode = -1;
                return;
            
        end
        
    case 'EDGES_ANGLE'
        
        switch RVE_Type
            
            case 'TYPE_A'
                
                if (Model_EDGES_ANGLE_a/2 >= Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2))
                    fprintf (1, '\nОшибка: вырожденная ячейка периодичности!\n');
                    fprintf (1, 'Проверьте значения геометрических параметров ячейки.\n');
                    ErrCode = -1;
                    return;
                end
                
                RVE_Frame_Points(1,:) = [-Model_EDGES_ANGLE_a - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(2,:) = [-Model_EDGES_ANGLE_a/2, -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(3,:) = [Model_EDGES_ANGLE_a/2, -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(4,:) = [Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                
                RVE_Frame_Points(5,:) = [-Model_EDGES_ANGLE_a - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), 0];
                RVE_Frame_Points(6,:) = [-Model_EDGES_ANGLE_a/2 - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), 0];
                RVE_Frame_Points(7,:) = [Model_EDGES_ANGLE_a/2 + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), 0];
                RVE_Frame_Points(8,:) = [Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), 0];
                
                RVE_Frame_Points(9,:) = [-Model_EDGES_ANGLE_a - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(10,:) = [-Model_EDGES_ANGLE_a/2, Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(11,:) = [Model_EDGES_ANGLE_a/2, Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(12,:) = [Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                
                RVE_Frame_Size = RVE_Frame_Points(12,:) - RVE_Frame_Points(1,:);
                
            case 'TYPE_B'
                
                if (Model_EDGES_ANGLE_a/2 >= Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2))
                    fprintf (1, '\nОшибка: вырожденная ячейка периодичности!\n');
                    fprintf (1, 'Проверьте значения геометрических параметров ячейки.\n');
                    ErrCode = -1;
                    return;
                end
                
                RVE_Frame_Points(1,:) = [-Model_EDGES_ANGLE_a - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), 0];
                RVE_Frame_Points(2,:) = [-Model_EDGES_ANGLE_a/2, 0];
                RVE_Frame_Points(3,:) = [Model_EDGES_ANGLE_a/2, 0];
                RVE_Frame_Points(4,:) = [Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), 0];
                
                RVE_Frame_Points(5,:) = [-Model_EDGES_ANGLE_a - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(6,:) = [-Model_EDGES_ANGLE_a/2 - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(7,:) = [Model_EDGES_ANGLE_a/2 + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(8,:) = [Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                
                RVE_Frame_Points(9,:) = [-Model_EDGES_ANGLE_a - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(10,:) = [-Model_EDGES_ANGLE_a/2 - Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(11,:) = [Model_EDGES_ANGLE_a/2 + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                RVE_Frame_Points(12,:) = [Model_EDGES_ANGLE_a + Model_EDGES_ANGLE_b * cosd(Model_EDGES_ANGLE_alpha/2), -Model_EDGES_ANGLE_b * sind(Model_EDGES_ANGLE_alpha/2)];
                
                RVE_Frame_Size = RVE_Frame_Points(8,:) - RVE_Frame_Points(9,:);
                
            otherwise
                
                fprintf (1, '\nОшибка функции Construct_RVE_Shell: недопустимое значение параметра RVE_Type !\n');
                ErrCode = -1;
                return;
            
        end
        
    case 'RVE_SIZE'
        
        switch RVE_Type
            
            case 'TYPE_A'
                
                Fraction = (Model_RVE_SIZE_L^2 + Model_RVE_SIZE_W^2) / (8 * Model_RVE_SIZE_L);
                
                if (Model_RVE_SIZE_L/2 - Fraction <= 0)
                    fprintf (1, '\nОшибка: вырожденная ячейка периодичности!\n');
                    fprintf (1, 'Проверьте значения геометрических параметров ячейки.\n');
                    ErrCode = -1;
                    return;
                end
                
                RVE_Frame_Points(1,:) = [-Model_RVE_SIZE_L/2, -Model_RVE_SIZE_W/2];
                RVE_Frame_Points(2,:) = [-Fraction, -Model_RVE_SIZE_W/2];
                RVE_Frame_Points(3,:) = [Fraction, -Model_RVE_SIZE_W/2];
                RVE_Frame_Points(4,:) = [Model_RVE_SIZE_L/2, -Model_RVE_SIZE_W/2];
                
                RVE_Frame_Points(5,:) = [-Model_RVE_SIZE_L/2, 0];
                RVE_Frame_Points(6,:) = [-Model_RVE_SIZE_L/2 + Fraction, 0];
                RVE_Frame_Points(7,:) = [Model_RVE_SIZE_L/2 - Fraction, 0];
                RVE_Frame_Points(8,:) = [Model_RVE_SIZE_L/2, 0];
                
                RVE_Frame_Points(9,:) = [-Model_RVE_SIZE_L/2, Model_RVE_SIZE_W/2];
                RVE_Frame_Points(10,:) = [-Fraction, Model_RVE_SIZE_W/2];
                RVE_Frame_Points(11,:) = [Fraction, Model_RVE_SIZE_W/2];
                RVE_Frame_Points(12,:) = [Model_RVE_SIZE_L/2, Model_RVE_SIZE_W/2];
                
                
                RVE_Frame_Size = RVE_Frame_Points(12,:) - RVE_Frame_Points(1,:);
                
            case 'TYPE_B'
                
                Fraction = (Model_RVE_SIZE_L^2 + Model_RVE_SIZE_W^2) / (8 * Model_RVE_SIZE_L);
                
                if (Model_RVE_SIZE_L/2 - Fraction <= 0)
                    fprintf (1, '\nОшибка: вырожденная ячейка периодичности!\n');
                    fprintf (1, 'Проверьте значения геометрических параметров ячейки.\n');
                    ErrCode = -1;
                    return;
                end
                
                RVE_Frame_Points(1,:) = [-Model_RVE_SIZE_L/2, 0];
                RVE_Frame_Points(2,:) = [-Fraction, 0];
                RVE_Frame_Points(3,:) = [Fraction, 0];
                RVE_Frame_Points(4,:) = [Model_RVE_SIZE_L/2, 0];
                
                RVE_Frame_Points(5,:) = [-Model_RVE_SIZE_L/2, Model_RVE_SIZE_W/2];
                RVE_Frame_Points(6,:) = [-Model_RVE_SIZE_L/2 + Fraction, Model_RVE_SIZE_W/2];
                RVE_Frame_Points(7,:) = [Model_RVE_SIZE_L/2 - Fraction, Model_RVE_SIZE_W/2];
                RVE_Frame_Points(8,:) = [Model_RVE_SIZE_L/2, Model_RVE_SIZE_W/2];
                
                RVE_Frame_Points(9,:) = [-Model_RVE_SIZE_L/2, -Model_RVE_SIZE_W/2];
                RVE_Frame_Points(10,:) = [-Model_RVE_SIZE_L/2 + Fraction, -Model_RVE_SIZE_W/2];
                RVE_Frame_Points(11,:) = [Model_RVE_SIZE_L/2 - Fraction, -Model_RVE_SIZE_W/2];
                RVE_Frame_Points(12,:) = [Model_RVE_SIZE_L/2, -Model_RVE_SIZE_W/2];
                
                RVE_Frame_Size = RVE_Frame_Points(8,:) - RVE_Frame_Points(9,:);
                
            otherwise
                
                fprintf (1, '\nОшибка функции Construct_RVE_Shell: недопустимое значение параметра RVE_Type !\n');
                ErrCode = -1;
                return;
            
        end
        
    case 'RVE_SIZE_EDGE'
        
        switch RVE_Type
            
            case 'TYPE_A'
                
                Fraction = Model_RVE_SIZE_EDGE_a/2;
                
                if (Model_RVE_SIZE_L/2 - Fraction <= 0)
                    fprintf (1, '\nОшибка: вырожденная ячейка периодичности!\n');
                    fprintf (1, 'Проверьте значения геометрических параметров ячейки.\n');
                    ErrCode = -1;
                    return;
                end
                
                RVE_Frame_Points(1,:) = [-Model_RVE_SIZE_EDGE_L/2, -Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(2,:) = [-Fraction, -Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(3,:) = [Fraction, -Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(4,:) = [Model_RVE_SIZE_EDGE_L/2, -Model_RVE_SIZE_EDGE_W/2];
                
                RVE_Frame_Points(5,:) = [-Model_RVE_SIZE_EDGE_L/2, 0];
                RVE_Frame_Points(6,:) = [-Model_RVE_SIZE_EDGE_L/2 + Fraction, 0];
                RVE_Frame_Points(7,:) = [Model_RVE_SIZE_EDGE_L/2 - Fraction, 0];
                RVE_Frame_Points(8,:) = [Model_RVE_SIZE_EDGE_L/2, 0];
                
                RVE_Frame_Points(9,:) = [-Model_RVE_SIZE_EDGE_L/2, Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(10,:) = [-Fraction, Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(11,:) = [Fraction, Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(12,:) = [Model_RVE_SIZE_EDGE_L/2, Model_RVE_SIZE_EDGE_W/2];
                
                
                RVE_Frame_Size = RVE_Frame_Points(12,:) - RVE_Frame_Points(1,:);
                
            case 'TYPE_B'
                
                Fraction = Model_RVE_SIZE_EDGE_a/2;
                
                if (Model_RVE_SIZE_L/2 - Fraction <= 0)
                    fprintf (1, '\nОшибка: вырожденная ячейка периодичности!\n');
                    fprintf (1, 'Проверьте значения геометрических параметров ячейки.\n');
                    ErrCode = -1;
                    return;
                end
                
                RVE_Frame_Points(1,:) = [-Model_RVE_SIZE_EDGE_L/2, 0];
                RVE_Frame_Points(2,:) = [-Fraction, 0];
                RVE_Frame_Points(3,:) = [Fraction, 0];
                RVE_Frame_Points(4,:) = [Model_RVE_SIZE_EDGE_L/2, 0];
                
                RVE_Frame_Points(5,:) = [-Model_RVE_SIZE_EDGE_L/2, Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(6,:) = [-Model_RVE_SIZE_EDGE_L/2 + Fraction, Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(7,:) = [Model_RVE_SIZE_EDGE_L/2 - Fraction, Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(8,:) = [Model_RVE_SIZE_EDGE_L/2, Model_RVE_SIZE_EDGE_W/2];
                
                RVE_Frame_Points(9,:) = [-Model_RVE_SIZE_EDGE_L/2, -Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(10,:) = [-Model_RVE_SIZE_EDGE_L/2 + Fraction, -Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(11,:) = [Model_RVE_SIZE_EDGE_L/2 - Fraction, -Model_RVE_SIZE_EDGE_W/2];
                RVE_Frame_Points(12,:) = [Model_RVE_SIZE_EDGE_L/2, -Model_RVE_SIZE_EDGE_W/2];
                
                RVE_Frame_Size = RVE_Frame_Points(8,:) - RVE_Frame_Points(9,:);
                
            otherwise
                
                fprintf (1, '\nОшибка функции Construct_RVE_Shell: недопустимое значение параметра RVE_Type !\n');
                ErrCode = -1;
                return;
            
        end
        
    otherwise
        
        fprintf (1, '\nОшибка функции Construct_RVE_Shell: недопустимое значение параметра RVE_Geom_Model !\n');
        ErrCode = -1;
        return;
    
end

fprintf (1, 'OK!\n');
